<?php

namespace App\Http\Controllers;

use Log;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Storage;

class captureImageController extends Controller
{

    public function storeImage(Request $request)
    {
        $request->validate([
            'file' => 'required|image|max:2048', // Maksimal 2MB
        ]);

        // Menyimpan gambar ke storage
        $path = $request->file('file')->store('hikvision', 'public');

        return response()->json(['status' => 'success', 'image_path' => $path]);
    }

    public function saveImage(Request $request)
    {
        // Validasi apakah gambar ada
        $request->validate([
            'image' => 'required|image|mimes:jpeg,png,jpg,gif|max:2048',
        ]);

        // Simpan gambar ke storage
        try {
            $image = $request->file('image');
            $filename = time() . '.' . $image->getClientOriginalExtension();
            $path = $image->storeAs('hikvision', $filename, 'public');

            return response()->json(['status' => 'success', 'image_path' => $path]);
        } catch (\Exception $e) {
            Log::error('Error saving image: ' . $e->getMessage());
            return response()->json(['status' => 'error', 'message' => 'Gagal menyimpan gambar: ' . $e->getMessage()], 500);
        }
    }

    public function captureImage()
    {
        // Konfigurasi IP kamera dan kredensial
        $camera_ip = '10.1.248.21'; // Ganti dengan IP kamera yang sesuai
        $username = 'admin';
        $password = 'support';

        // URL untuk mengambil snapshot
        $snapshot_url = "http://$camera_ip/ISAPI/Streaming/channels/101/picture";

        // Ambil gambar dari kamera
        $response = Http::withBasicAuth($username, $password)->get($snapshot_url);

        if ($response->successful()) {
            // Simpan gambar ke storage
            $filename = 'hikvision_snapshot_' . time() . '.jpg';
            Storage::disk('public')->put('captureAdiva/' . $filename, $response->body());

            $body = [
                "api_key" => "iH21K14bt2p78TkhHbnjr2ffPVfGaB",
                "sender" => "6285161310017",
                "number" => "6285161310017",
                "media_type" => "image",
                "caption" => "Berikut adalah Hasil Capture CCTV",
                "url" => url('storage/captureAdiva/' . $filename),
            ];
            $responseApiWa = Http::withHeaders([
                'Content-Type' => 'application/json',
            ])->post('https://wa.sinkron.com/send-media', $body);

            return response()->json([
                'status' => true,
                'message' => 'Berikut adalah Hasil Capture CCTV',
                'responApiWa' => $responseApiWa->json(),
                'body' => $body,
                'url_image' => url('storage/captureAdiva/' . $filename),
            ], 200);

        } else {
            return response()->json(['status' => 'error', 'message' => 'Gagal mengambil gambar dari kamera.'], 500);
        }
    }

}
